#ifndef _DTWOBJ_HPP
#define _DTWOBJ_HPP

#include "dtobject.hpp"
#include <iostream>
#include <iomanip>

#if defined( __BUILDING_DTWCM_DLL__ )
#  define DTWOBJ_DECLSPEC METADECLSPEC_EXPORT
#else
#  define DTWOBJ_DECLSPEC METADECLSPEC_IMPORT
#endif

oapp<WUInt> & METAEXPORTDEF GetPadder();
#define Pad( __x ) GetPadder()( __x )

extern void METAEXPORTDEF TabTo( ostream & src, WUInt curr, WUInt column );
#define _DT( __x )  WCTEXT( __x )

enum MMWCodeGeneration {
    MM_CG_AppInit,                      // "WRichTextBox::GetRegistered.."
    MM_CB_HPP,                          // form1.hpp
    MM_CB_CPP,                          // form1.cpp
    MM_CB_RC,                           // form1.rc

    MM_CG_FORM_CreateDecl,              // "WBool Create( WWindow * );"
    MM_CG_FORM_CreateDefn,              // "WBool Form1::Create( WWindow * )"
    MM_CG_FORM_CallCreate,              // "ok = WWindow::Create( parent, ... )"

    MM_CG_HPP_EnumeratorID,             // "CB_1 = 101,"
    MM_CG_HPP_EventDecl,                // "WBool cb_1_Clicked( ... );"
    MM_CG_HPP_MemberDecl,               // "WCommandButton *  cb_1;"

    MM_CG_ConstructorInitializer,       // "    , cb_1( NULL )"
    MM_CG_ConstructorCode,              // "// any constructor code"

    MM_CG_InitNew,                      // "cb_1 = new WCommandButton;"
    MM_CG_InitEventHandlerList,         // "WEventHandlerList cb_1_Event..."
    MM_CG_InitEventHandlers,            // "cb_1->SetEventHandlerList( ... );"
    MM_CG_RemoveEventHandlers,          // "cb_1->RemoveEventHandlerList( ... );"
    MM_CG_InitDDXDataSource,            // "cb_1->SetDDXDataSource( ... );"
    MM_CG_InitCreate,                   // "cb_1->Create( ... );"
    MM_CG_InitProperties,               // "cb_1->SetFont( ... );"
    MM_CG_CallCreateEventHandler,       // "cb_1->CallEventHandler( ... );"
    MM_CG_CallDestroyEventHandler,      // "cb_1->CallEventHandler( ... );"
    MM_CG_InitTransaction,              // "trans_1->Connect( ... );"
    MM_CG_InitQuery,                    // "query_1->Open( ... );"
    MM_CG_AutoOpenQuery,                // "WOptima::AuotOpen...;"
    MM_CG_InitTabControl,               // "_TabForm1->Create( this, ...);"

    MM_CG_FiniTransaction,              // "trans_1->Disconnect();"
    MM_CG_FiniQuery,                    // "query_1->Close();"
    MM_CG_FiniDelete,                   // "delete cb_1;"
    MM_CG_FiniReset,                    // "cb_1 = NULL;"

    MM_CG_MemberFunctions,              // "WBool Form1::..."

    MM_CG_DDXMember,                    // "WString     ddxNum;"
    MM_CG_DDXGetDefault,                // "ddx->gender = 'M';"

    MM_CG_RC_Defines,                   // "#define CB_1 101"
    MM_CG_RC_MainLevel,                 // "SPINDIAL_1_DATA RCDATA"
    MM_CG_RC_Control,                   // "CB_1 CONTROL ..."

    MM_CG_StaticData,                   // "WStaticToolbarData __Form1_Base::toolb_1_table[] = ..."
    MM_CG_HPP_BaseMemberFuncDecl,       // WBool __Base_toolb_1_ClickEvent(...);
    MM_CG_CPP_BaseMemberFuncDefn,       // WBool __Base_toolb_1_ClickEvent(...) {...}
};

class METAEXPORTCLASSDEF DTWObject : public DTObjectBase
{
    public:
        DTWObject( const MetaObject * );

        virtual void            DTGetRectangle( WRect & r,
                                                WBool abs = FALSE ) const;
        virtual void            DTSetRectangle( const WRect & r );

        virtual void            DTGetClientRectangle( WRect & r ) const;

        virtual void            DTGetRCRectangle( WRect & r ) const;

        virtual WRect           DTMapPixelsToDLU( const WRect & pix ) const;
        virtual WRect           DTMapDLUToPixels( const WRect & dlu ) const;

        virtual void            DTBringToTop();

        virtual void            DTRepaint();

        virtual void            GetRequiredIncludes( WStringList & includes ) const;
        virtual void            GenerateCode( MMCodeGeneration, ostream &, MMCodeGenerationParms & );
};

#endif // _DTWOBJ_HPP
